"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
import pytest
import yaml

from script.game import fight

# 所有测试用例执行以前，打印 【开始测试】，所用测试用例执行结束后，打印【测试结束】
def setup_module():
    print("开始测试")

def teardown_module():
    print("测试结束")

# 每一条用例执行之前，打印【开始战斗】，每一条用例执行结束后，打印【战斗结束】
def setup_function():
    print("开始战斗")

def teardown_function():
    print("战斗结束")

def test_fight_lose():
    # 定义英雄属性值
    EZ_hp = 1100
    EZ_power = 190
    Jinx_hp = 1000
    Jinx_power = 210
    # 调用被测对象
    # 导包快捷键 alt + enter
    # 定义变量，接收战斗结果
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    # 断言战斗结果
    assert result == "Jinx 赢了"

def test_fight_win():
    # 定义英雄属性值
    EZ_hp = 1100
    EZ_power = 190
    Jinx_hp = 900
    Jinx_power = 210
    # 调用被测对象
    # 导包快捷键 alt + enter
    # 定义变量，接收战斗结果
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    # 断言战斗结果
    assert result == "EZ 赢了"

@pytest.mark.parametrize(
    "EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected",
    (
        [1100, 190, 1000, 210, "Jinx 赢了"],
        [1100, 190, 900, 210, "EZ 赢了"],
        [1100, 190, 1100, 190, "平局"]
    ),
    ids=("lose", "win", "draw")
)
def test_fight_by_params(EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected):
    # 定义变量，接收战斗结果
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    print(result)
    # 断言战斗结果
    assert result == expected

# 读取 yaml 文件
def get_yaml():
    '''
    读取 yaml 文件的内容
    :return: 返回 [[]] 格式的数据
    '''
    with open("../data/fight_data.yaml", "r") as f:
        data = yaml.safe_load(f)
    return data

@pytest.mark.parametrize(
    "EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected",
    get_yaml()["data"],
    ids=get_yaml()["ids"]
)
def test_fight_by_yaml(EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected):
    # 定义变量，接收战斗结果
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    print(result)
    # 断言战斗结果
    assert result == expected